using System;
using System.Collections.Generic;
using System.Text;

using XNAF = Microsoft.Xna.Framework;
using XNAG = Microsoft.Xna.Framework.Graphics;

namespace XGAE.Framework.Services.Debug
{
    /// <summary>
    /// A set of tools that can assist the creation of an AI brain visually.
    /// </summary>
    public interface IVisual
    {
        /// <summary>
        /// Print some text to the engine's console.
        /// </summary>
        /// <param name="text"></param>
        void Print(string text);

        /// <summary>
        /// Draw a line specified by relative coordinates.
        /// </summary>
        /// <param name="pt1"></param>
        /// <param name="pt2"></param>
        /// <param name="color"></param>
        void Line(XNAF.Vector3 pt1, XNAF.Vector3 pt2, XNAG.Color color);

        /// <summary>
        /// Highlight the animat in a certain colour.
        /// </summary>
        /// <param name="color"></param>
        void Glow(XNAG.Color color);
    }
}
