using System;
using System.Collections.Generic;
using System.Text;

namespace XGAE.Body.Motion
{
    /// <summary>
    /// The base interface stores all the data used by the implementation.  This is defined in the 
    /// XML model, so the mechanical manipulation of data can be generated automatically.
    /// </summary>
    interface IMotionBase
    {
        /// <summary>
        /// Interface Handling 
        /// </summary>
        Backend.IMotion Backend{ get; }

        /// <summary>
        /// The two parameters that are used to influence the movement actions. These are
        /// parameters to degrade the quality of the requests so that they do not seem perfect.
        /// </summary>
        float Strength { get; set;}
        float Accuracy { get; set;}
    }
}
