/*********************************************************************************************************
 * File:            NavigationManager.cs
 * Description:     This file is generated automatically by the tools. Do not edit!
 ********************************************************************************************************/

using System;
using System.Collections.Generic;
using System.Text;

using XGAE;
using XGAE.Framework;
using xServ = XGAE.Framework.Services;
using xBody = XGAE.Framework.Body;

namespace XGAE.Abilities.Navigation
{
    /// <summary>
    /// Wrapper class that implements all of the glue-code to get the module working.  
    /// </summary>
    class NavigationManager : NavigationModule
    {
        public NavigationManager() : base() { }

        /// <summary>
        /// Return a new interface of a given type.
        /// </summary>
        /// <param name="name"></param>
        /// <returns></returns>
        public override Interface Export(string name)
        {
            if (name == "Simple")
            {
                Interface i = new NavigationSimple(this) as Interface;
                return i;
            }
            if (name == "Conversion")
            {
                Interface i = new NavigationConversion(this) as Interface;
                return i;
            }
            if (name == "Execute")
            {
                Interface i = new NavigationExecute(this) as Interface;
                return i;
            }

            //Warning("Component " + m_type + " does not export interface '" + name + "'.", __FILE__, __LINE__);
            return null;
        }

	    /// <summary>
	    /// Store dependencies for convenience, as passed by the architecture.
	    /// </summary>
	    /// <param name="name"></param>
	    /// <param name="i"></param>
	    /// <returns></returns>
        public override bool Import(string name, Interface i)
        {
            if (name == "motion"  &&  Interface.IsCompatible(i.Version, 0x0004))
	        {
                this._motion = i as xBody.Motion.IRelative;
                if (this._motion!=null) return true;
            }
            if (name == "physics"  &&  Interface.IsCompatible(i.Version, 0x0003))
	        {
                this._physics = i as xBody.Physics.IRelative;
                if (this._physics != null) return true;
            }
            if (name == "state"  &&  Interface.IsCompatible(i.Version, 0x0004))
	        {
                this._state = i as xBody.Physics.IState;
	            i.RegisterListener( this );
                if (this._state != null) return true;
            }
            if (name == "space"  &&  Interface.IsCompatible(i.Version, 0x0001))
	        {
                this._space = i as xBody.Vision.ISpace;
                if (this._space != null) return true;
            }
            if (name == "visual"  &&  Interface.IsCompatible(i.Version, 0x0004))
	        {
                this._visual = i as xBody.Vision.ISymbolic;
	            i.RegisterListener( this );
                if (this._visual != null) return true;
            }
            if (name == "debug"  &&  Interface.IsCompatible(i.Version, 0x0001))
	        {
                this._debug = i as xServ.Debug.IVisual;
                if (this._debug != null) return true;
            }
         
            //Warning( "Component " + m_type + " cannot import interface '" + name + "'.", __FILE__, __LINE__ );
            return false;
        }

	    /// <summary>
        /// Internal hard-coded table to dispatch the messages automatically.
	    /// </summary>
        /// <param name="message"></param>
        public override void Dispatch(Message message)
        {
            if (message >= "Collision")
	        {
                xBody.Physics.CollisionMessage cm = (xBody.Physics.CollisionMessage)message;
                base.OnCollision(cm.Normal);
            }
        }
    }
}
